#include <stdio.h>
#include <stdint.h>
#include <cuda_runtime.h>
#include <string.h>

#include "raylib.h"

__global__ void test_image(uint8_t *image);

int main() {
  const int size_x = 100;
  const int size_y = 100;
  uint8_t *image_d;
  Image image = GenImageColor(size_x, size_y, BLUE);
  SetTraceLogLevel(LOG_ERROR);

  InitWindow(size_x, size_y, "cuda teseteroni");

  cudaMalloc((void **)&image_d, 100 * 100 * 4);
  test_image<<<1, dim3(3,3)>>>(image_d); 
  cudaDeviceSynchronize();
  //for(;;);
  
  //if(!IsWindowFullscreen()) ToggleFullscreen();

  while(!WindowShouldClose()) {
    cudaMemcpy(image.data, (void **)image_d, 100 * 100 * 4, cudaMemcpyDeviceToHost);
    //memset(image.data, (int32_t)0x0000ff, 100 * 100 * 4);
    BeginDrawing();
    DrawTexture(LoadTextureFromImage(image), 0, 0, WHITE);
    EndDrawing();
  }
  
  



  return 0;
}
